#ifndef EEBIE_WRITER_H
#define EEBIE_WRITER_H

#include"ebml.h"

#include<stddef.h>

#define EBML_WRITE_MAXIMUM_DEPTH 128

typedef size_t(*EBMLWriteCallback)(void *ud, const void *data, size_t length);

typedef struct {
	int currentDepth;
	uint64_t stack[EBML_WRITE_MAXIMUM_DEPTH];
	
	EBMLWriteCallback callbackWrite;
	
	uint8_t *buffer;
	size_t bufferLen;
	size_t bufferCapacity;
	
	void *ud;
} EBMLWriter;

void ebml_writer_init(EBMLWriter *this);

void ebml_writer_push(EBMLWriter *this, uint64_t id);
void ebml_writer_pop(EBMLWriter *this);

void ebml_writer_put(EBMLWriter *this, uint64_t id, EBMLElementType type, EBMLPrimitive primitive);

#endif
